###########################################
###              jWarn v0.2             ###
###########################################
##      Requires: EventScripts v2.*     ###
##  By James Haigh [nitrouskillers.com]  ##
###########################################

## Thanks to:
# - Venjax for creating the original vWarn
# - SuperDave for helping me fix (many) parts of the code ;)
# - sn4k3 for helping me with some es.msg problems
# - GODJonez for big help with Popuplib
# - british.assassin for help with auth and the auth list


# Don't remove!
import es, popuplib, os.path, pickle, services, gamethread

##########################################################################################################################################
# Change these variables to your liking.
allow_warn_admins = 1 # Allow admins to warn other admins?
notify_admins = 1 # Notify all admins (instead of just the person who issued the warning) when someone gets warned?
slay_warned = 1 # Slay a player when they receive a warning?
anonymous = 1 # Anonymous Warnings (the admins name isn't shown to the warned player)
warns_kick = 3 # Amount of warns to kick a player
warns_ban = 6 # Amount of warns to ban a player
warns_ban_time = 2880 # Time to ban a player (in minutes). [default = 2880 = 48 hours]
allow_see = 1 # Allow admins to !see how many warnings a player has (!see playername)
allow_player_see_warnings = 1 # Allow players to see their !warnings
##########################################################################################################################################


### Don't modify anything else unless you know what you're doing!

# Please do not modify or remove :)
info = es.AddonInfo()
info['name']        = 'jWarn'
info['version']     = '0.2'
info['author']      = 'James Haigh'
info['url']         = 'nitrous.killers@googlemail.com'
info['description'] = 'Warns (and optionally kicks/slays/bans) players who break the rules.'

authorized_players = []

# Gets cool information
def _wrap_es_getargc(varname):
   x = es.getargc()
   es.set(varname, str(x))

def _wrap_es_getargv(varname, argument):
   x = es.getargv(argument)
   es.set(varname, str(x))

def _wrap_es_getargs(varname):
   x = es.getargs()
   es.set(varname, x)

def _wrap_es_getcmduserid(varname):
   x = es.getcmduserid()
   es.set(varname, str(x))

def load():
   global allow_see, allow_player_see_warnings, warnings_db
   # Does the DB file exist?
   if os.path.isfile(es.getAddonPath('jwarn') + '/data.txt'):
      # Get the size of the file.
      filecheck = os.path.getsize(es.getAddonPath('jwarn')+ '/data.txt')
      # If the file is empty, create a new dictionary for the database and save it to the file.
      if filecheck == 0:
         warnings_db = {}
         f = open(es.getAddonPath('jwarn') + '/data.txt', 'w');
         pickle.dump(warnings_db,f)
         f.close()
      else:
         # The file has some data in it. Load it up.
         f = open(es.getAddonPath('jwarn')+ '/data.txt', 'r')
         warnings_db = pickle.load(f)
         f.close()
   else:
      # If the db doesn't exist, tell the serveradmin.
      es.dbgmsg(0, 'Can\'t open the data.txt file. Please ensure that it is in the /cstrike/addons/eventscripts/jwarn directory.')
   # Set up some variables.
   es.set('vtoke2', '0')
   es.set('vtoke3', '0')
   es.set('admin_userid', '0')
   es.set('admin_steamid', '0')
   es.set('admin_name', '0')
   es.set('tokefix', '0')
   # Variables which are unique to this script. Please don't remove :)
   es.set('jwarn_active', '1')
   es.set('jwarn_ver', '0.2')
   es.makepublic('jwarn_active')
   es.makepublic('jwarn_ver')
   # Call AUTH.
   auth = services.use('auth')
   auth.registerCapability('jwarn', auth.ADMIN)
   # Register the warn command.
   es.regsaycmd('warn','jwarn/warnem','Warns players')
   # Register other commands if they're needed.
   if allow_player_see_warnings == 1:
      es.regsaycmd('!warnings','jwarn/warnings','Allows players to see their warnings')
   if allow_see:
      es.regsaycmd('!see','jwarn/see','Allows admins to see player\'s warnings')

def player_activate(event_var):
   # Check whether the player is an admin. (Delayed by 10 seconds so we don't get STEAM_ID_PENDING).
   gamethread.delayed(10,check,event_var['userid'])

def player_disconnect(event_var):
   global authorized_players
   if int(event_var['userid']) in authorized_players:
      authorized_players.remove(int(event_var['userid']))

def unload():
   global warnings_db, authorized_players
   # Save the database.
   file = open(es.getAddonPath('jwarn') + '/data.txt', 'w')
   pickle.dump(warnings_db, file)
   file.close()
   # Remove stuff from memory.
   del authorized_players
   del file
   del warnings_db
   # Remove the say commands.
   es.unregsaycmd('warn')
   es.unregsaycmd('!warnings')
   es.unregsaycmd('!see')

def es_map_start(event_var):
   global warnings_db
   # Save the database.
   file = open(es.getAddonPath('jwarn') + '/data.txt', 'w')
   pickle.dump(warnings_db, file)
   file.close()

def check(userid):
   global authorized_players
   auth = services.use('auth')
   if auth.isUseridAuthorized(userid,'jwarn'):
      # If the player is an admin, add them to our admin list.
      authorized_players.append(int(userid))

def warnings():
   global warnings_db
   # Get the ID of the player who wants to see their warnings.
   _wrap_es_getcmduserid('_player_userid')
   # Get their STEAM ID.
   _player_steamid = es.getplayersteamid(es.ServerVar('_player_userid'))
   # Have they been warned?
   if _player_steamid in warnings_db:
      # Yes, they've been warned. Show them their warnings.
      es.menu('5',es.ServerVar('_player_userid'),'->1. Warnings\n \nYou have ' + str(warnings_db[_player_steamid]) + ' warnings.\n \n->0. Close')
   else:
      # No warnings. Let them know.
      es.menu('5',es.ServerVar('_player_userid'),'->1. Warnings\n \nYou haven\'t received any warnings yet.')

def see():
   _wrap_es_getcmduserid('see_adminuserid')
   global admins, warnings_db, authorized_players
   es.set('see_admin_steamid',es.getplayersteamid(es.ServerVar('see_adminuserid')))
   # Is the player an admin?
   if int(es.ServerVar('see_adminuserid')) in authorized_players:
      _wrap_es_getargv('see_playername', 1)
      # Did the admin specify a player name?
      if es.ServerVar('see_playername') == '':
         # Nope. Let them know.
         es.tell(es.ServerVar('see_adminuserid'),'\x04No player specified')
      else:
         # Get the USER ID.
         see_id = es.getuserid(es.ServerVar('see_playername'))
         # Is the player active?
         if see_id == 0:
            # Let the admin know if they chose an invalid player.
            es.menu('5',es.ServerVar('see_adminuserid'),'->1. Error\nNo such user!')
         else:
            # Get their STEAM ID & Name.
            see_steamid = es.getplayersteamid(see_id)
            see_name = es.getplayername(see_id)
            es.set('see_steamid',see_steamid)
            es.set('see_name',see_name)
            # If they have any warnings.
            if see_steamid in warnings_db:
               # Send data to the popup method.
               see_popup(warnings_db[see_steamid],see_name,es.ServerVar('see_adminuserid'))
            else:
               # Let the admin know that the player doesn't have any warnings.
               es.menu('5',es.ServerVar('see_adminuserid'),'->1. ' + see_name + '\nThis player has no warnings.\n \n->0. Close')
   else:
      es.tell(es.ServerVar('see_adminuserid'),'\x04You are not an admin.')

def see_popup(warns,name,userid):
   global warnings_db
   # Create the popup.
   sz = popuplib.create('edit_warns')
   es.set('see_name',name)
   # Call see_manuselect() when the user chooses an option.
   sz.menuselect = see_menuselect
   # Add the data.
   sz.addline('->1. ' + name)
   sz.addline('\nThis player has ' + str(warns) + ' warnings.')
   sz.addline(' ')
   sz.addline('->2. Remove 1 warning')
   sz.addline('->3. Remove all warnings')
   sz.addline('->0. Close')
   # Send the popup.
   popuplib.send('edit_warns', userid)

def see_menuselect(userid, choice, popupid):
   global warnings_db
   steamid = es.ServerVar('see_steamid')
   if choice == 3:
      # Remove all warnings for the specified STEAM ID.
      del warnings_db[str(steamid)]
      es.tell(es.ServerVar('see_adminuserid'),'\x04All warnings for ' + es.ServerVar('see_name') + ' have been deleted.')
   elif choice == 2:
      # Remove one warning from that player.
      new_warnings = warnings_db[str(steamid)] - 1
      warnings_db[str(steamid)] = int(new_warnings)
      es.tell(es.ServerVar('see_adminuserid'),'\x04Player now has ' + str(new_warnings) + ' warnings.')
   # Unsend the popup.
   popuplib.unsendname('edit_warns',es.ServerVar('see_adminuserid'))
   # Delete the popup from memory.
   popuplib.delete('edit_warns')


def warnem():
   global authorized_players 
   # Find out who is trying to issue a warning.
   _wrap_es_getcmduserid('admin_userid')
   es.set('admin_name',es.getplayername(es.ServerVar('admin_userid')))
   es.set('admin_steamid',es.getplayersteamid(es.ServerVar('admin_userid')))
   # Is the player an admin?
   if int(es.ServerVar('admin_userid')) in authorized_players:
      # If so, issue the warning.
      es.doblock('jwarn/warn_player')
   else:
      es.tell(es.ServerVar('admin_userid'),'\x04You are not an admin.')

def warn_player():
   # Get the variables we'll need.
   global admins, allow_warn_admins, notify_admins, slay_warned, anonymous, warns_kick, warns_ban, warns_ban_time, use_globalban, authorized_players, warnings_db
   # Get the playername and the reason and store them in variables.
   _wrap_es_getargv('vtoke2', 1)
   _wrap_es_getargs('vtoke3')
   # This was here from vWarn. Don't ask me why, how, or what it does.
   es.format('tokefix', '%1 ',es.ServerVar('vtoke2'))
   es.server.cmd('es_string vtoke3 replace server_var(tokefix)')
   es.server.cmd('es_string vtoke3 replace server_var(vtoke2)')
   # Store the reason and userid of the player in Python vars
   warned_reason = es.ServerVar('vtoke3')
   warned_id = es.getuserid(es.ServerVar('vtoke2'))
   if es.ServerVar('vtoke2') == '' or es.ServerVar('vtoke3') == '':
      es.tell(es.ServerVar('admin_userid'),'\x04Syntax is: warn playername reason')
   else:
      # Is the player on the server?
      if warned_id == 0:
         # If not, show an error to the admin.
         es.menu('5',es.ServerVar('admin_userid'),'->1. Error!\nNo such user!\n \n->0. Close')
      else:
         # We have the player, let's get his/her Steam ID.
         warned_steamid = es.getplayersteamid(warned_id)
         # Are we trying to warn an admin?
         if warned_id in authorized_players and allow_warn_admins == 0:
            # Oops...
            es.menu('5',es.ServerVar('admin_userid'),'->1. Error\nYou can\'t warn another admin!\n \n->0. Close')
         else:
            # Get the player's name for later.
            warned_name = es.getplayername(warned_id)
            # If the user hasn't yet received any warnings...
            if not warned_steamid in warnings_db:
               # Add a new key and give it a value of 1.
               warnings_db[warned_steamid] = 1
               new_warnings = 1
            else:
               # Add the warning.
               new_warnings = warnings_db[warned_steamid] + 1
               warnings_db[warned_steamid] = new_warnings
            if notify_admins == 1:
               # If we're notifying all admins, send them all a message.
               for tempid in authorized_players:
                     es.menu('5',str(tempid),'->1. Player Warned\n' + es.ServerVar('admin_name') + ' just issued a warning to ' + warned_name + '.\n \n->2. Reason\n' + warned_reason + '\n \n->3. Warns\nThe player has a total of ' + str(new_warnings) + ' warning(s).\n \n->0. Close')
            else:
               # If we're not telling all the admins, just tell the admin who issued the warning.
               es.menu('5',es.ServerVar('admin_userid'),'->1. Player Warned\n' + warned_name + ' has been issued a warning.\n \n->2. Reason\n' + warned_reason + '\n \n->3. Warnings\nThe player has a total of ' + str(warns) + ' warning(s).\n \n->0. Close')
            if slay_warned == 1:
               # Slay the bad player. 
               es.server.cmd('damage ' + str(warned_id) + ' 100 ')
            # Show the user their warning.
            # ..if we want the warning to be anonymous...
            if anonymous == 1:
               es.menu('0',warned_id,'->1. Warning\nYou have been issued a warning.\n \n->2. Reason\n' + warned_reason + '\n \n->0. Close')
            else:
               es.menu('0',warned_id,'->1. Warning\nYou have been issued a warning by ' + es.ServerVar('admin_name') + '.\n \n->2. Reason\n' + warned_reason + '\n \n->0. Close')
            # If the user is about to have their last warning before they get banned.
            if new_warnings >= warns_ban:
               # Ban the user.
               es.server.cmd('banid ' + str(warns_ban_time) + ' ' + warned_steamid)
               # Kick
               es.server.cmd('kickid ' + warned_steamid + ' ' + warned_reason)
               # Notify everyone.
               es.msg('\x04' + warned_name + ' has been given enough warnings and therefore banned from the server.')
            # Else, if the user is about to be kicked.
            elif new_warnings >= warns_kick:
               # Kick the user.
               es.server.cmd('kickid ' + warned_steamid + ' ' + warned_reason)
               # Notify everyone.
               es.msg('\x04' + warned_name + ' has been given enough warnings and therefore kicked from the server.')
